var tbVersion;

browser.ecodmsapi.log("Startup...");

browser.runtime.getBrowserInfo().then(function (info) {
    tbVersion=info.version;
});

var menuVisibleState = true;
var sendMenu = browser.menus.create({
  id: "sendToDms",
  title: browser.i18n.getMessage("sendToDms"),
  visible: true,
  contexts: ["page","message_list"],
  async onclick(info, tab) {
	
	console.log("Send to dms clicked");
	if (info.pageUrl)
	{
               
                
              
                
		browser.messageDisplay.getDisplayedMessages(tab.id).then(function (msgList) {
				
				var msgIds = new Array();
				for (var i = 0; i < msgList.length; i++)
				{
					msgIds[i]=msgList[i].id;
				}
			
				browser.ecodmsapi.ecoDMS_doArchive(msgIds);	
				
			});
	}
	else
	{
		var msgIds = new Array();
		for (var i = 0; i < info.selectedMessages.messages.length; i++)
		{
			msgIds[i]=info.selectedMessages.messages[i].id;
		}
		browser.ecodmsapi.ecoDMS_doArchive(msgIds);
	}
  }
  
},function(){console.log("Callback called.");});

browser.menus.onShown.addListener((info, tab) => {
		
		if (info.contexts.includes("message_list") || info.contexts.includes("page"))
		{
			var visible = false;
			if (info.contexts.includes("page"))
				visible = true;
			else
				visible = info.selectedMessages.messages.length>0;
		
			if (menuVisibleState!=visible)
			{
				menuVisibleState = visible;
				browser.menus.update("sendToDms", { visible: visible });
				browser.menus.refresh();
			}
		}
});

browser.browserAction.onClicked.addListener((tab) => 
{
    browser.browserAction.isEnabled({tabId: tab.id}).then(function(enabled) {
        if (enabled)
		{
			 browser.messageDisplay.getDisplayedMessages(tab.id).then(function (msgList) {
				
				var msgIds = new Array();
				for (var i = 0; i < msgList.length; i++)
				{
					msgIds[i]=msgList[i].id;
				}
			
				browser.ecodmsapi.ecoDMS_doArchive(msgIds);	
				
				
			});
            
		}
    });
    
    
});

browser.composeAction.onClicked.addListener((tab,info) => 
{
     browser.composeAction.isEnabled({tabId: tab.id}).then(function(enabled) {
        if (enabled)
            browser.ecodmsapi.ecoDMS_doSendAndArchive();
    });
});

browser.tabs.onUpdated.addListener((tabId,changeInfo,tab) => 
{
    browser.messageDisplay.getDisplayedMessages(tab.id).then(function (msgList) {
        
        let hasMessages = msgList.length > 0;
        
        //browser.menus.update("sendToDms", { visible: hasMessages });
        if (hasMessages)
            browser.browserAction.enable(tab.id);
        else
            browser.browserAction.disable(tab.id);
        
    });
    
    
    
    
});

var allattachmentMenu = browser.menus.create({
	id: "sendAllAttachmentToDms",
	title: browser.i18n.getMessage("attachmentsToDms"),
	visible: true,
	contexts: ["all_message_attachments"],
	async onclick(info,tab) {
		let tabs = await messenger.tabs.query({ active: true, currentWindow: true });
		let message = await messenger.messageDisplay.getDisplayedMessage(tabs[0].id);
		
		var msgIds = [];
		var attFiles = [];
		var remainingAtts = [];
		
		for(var ct = 0; ct < info.attachments.length; ct++)
		{
		    remainingAtts[ct] = info.attachments[ct];
		}
		
		var tmpAtts = await getAttachments(message, info.attachments, remainingAtts);
    	for(var ct = 0; ct < tmpAtts.length; ct++)
		{
		    var att = tmpAtts[ct];
		    var fileObj = await browser.messages.getAttachmentFile(att.id, att.partName);
			attFiles[ct] = fileObj;
            msgIds[ct] = att.id;		    
		}
		
		browser.ecodmsapi.ecoDMS_doArchiveAttachment(msgIds,attFiles);    
	}
},function(){console.log("All Attachment Callback called.");});

var attachmentMenu = browser.menus.create({
  id: "sendAttachmentToDms",
  title: browser.i18n.getMessage("attachmentToDms"),
  visible: true,
  contexts: ["message_attachments"],
  async onclick(info, tab) {
	let tabs = await messenger.tabs.query({ active: true, currentWindow: true });
	let message = await messenger.messageDisplay.getDisplayedMessage(tabs[0].id);
	
		var msgIds = [];
		var attFiles = [];
		var remainingAtts = [];
		
		for(var ct = 0; ct < info.attachments.length; ct++)
		{
		    remainingAtts[ct] = info.attachments[ct];
		}
		
		var tmpAtts = await getAttachments(message, info.attachments, remainingAtts);

		for(var ct = 0; ct < tmpAtts.length; ct++)
		{
		    var att = tmpAtts[ct];
		    var fileObj = await browser.messages.getAttachmentFile(att.id, att.partName);
			attFiles[ct] = fileObj;
            msgIds[ct] = att.id;		    
		}
		
		browser.ecodmsapi.ecoDMS_doArchiveAttachment(msgIds,attFiles);      
  }
  
},function(){console.log("Attachment Callback called.");});

browser.composeScripts.register({js: [{file: "content/sendscript.js"}]});

async function getAttachments(msg, attachments, remainingAtts) 
{
    var ret = [];
    
    var atts = await browser.messages.listAttachments(msg.id);

    for(let attachment of atts)
    {
        var checkSize = true;
    
        if(typeof attachment.message !== 'undefined')
        {
            checkSize = false; // size is different for eml attachments
        }
        
        var containsPart = false;
        var attToRemove;
        
        for (let attToCheck of attachments)
	    {
	        var ok = false;
	        
	        if(attToCheck.partName === attachment.partName)
	        {
	            ok = true;
	        }
	        else if(attToCheck.contentType === attachment.contentType &&
	             attToCheck.name === attachment.name)
	        {
	            if(checkSize)
	            {
	                if(attToCheck.size === attachment.size)
	                {
	                    ok = true;
	                }
	            }
	            else
	            {
	                ok = true;
	            }
	        }
	        
	        if(ok)
	        {
	        	containsPart = true;
	            attToRemove = attToCheck;
	            break;
	        }
	    }
	    
        if(containsPart)
        {
            var retmsg = {};
            retmsg.id = msg.id;
            retmsg.partName = attachment.partName;
            
            ret.push(retmsg);

            const index = remainingAtts.indexOf(attToRemove);
            
            if(index > -1)
            {
                remainingAtts.splice(index, 1);
            }
         
            if(remainingAtts.length == 0)
            {
                break;
            }            
        }
        
        if(!checkSize) // message
        {
            var subMsgAtts = await getAttachments(attachment.message, attachments, remainingAtts);
            Array.prototype.push.apply(ret, subMsgAtts);
        }
    }
    
    return ret;
}

async function scriptMessage(message) {
  
    browser.ecodmsapi.log("Got message: "+message.cmd);
    if (message.cmd == "register")
    {
        await browser.composeAction.disable();
        await browser.ecodmsapi.registerSendStateObserver();
    }
}

async function onCommand(cmd, state) {
    browser.ecodmsapi.log("onCommand: "+cmd+" / "+state);
    if (cmd === "sendButtonState")
    {
        if (state===true)
        {
            browser.composeAction.disable();
        }
        else
        {
            browser.composeAction.enable();
        }
        
        return state;
    }
    else if (cmd === "translate")
    {
        return browser.i18n.getMessage(state);
    }
    else if (cmd === "version")
    {
        return tbVersion;
    }
        
 
}

browser.ecodmsapi.onCommand.addListener(onCommand);
browser.runtime.onMessage.addListener(scriptMessage);

browser.ecodmsapi.log("Startup complete.");
